//+------------------------------------------------------------------+
//|                                           .mq4 |
//|                      Copyright  2008, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+

#property copyright "Copyright  2010"
#property link      ""

#import "wininet.dll"
   int InternetOpenA(string a0, int a1, string a2, string a3, int a4);
   int InternetOpenUrlA(int a0, string a1, string a2, int a3, int a4, int a5);
   int InternetReadFile(int a0, string a1, int a2, int& a3[]);
   int InternetCloseHandle(int a0);
#import

#include <stdlib.mqh>
extern string     Main                             = "-------Main Settings------";
extern int        MaxTrades                        = 1;     
extern int        TakeProfit                       = 0;     
extern bool       StealthMode_TakeProfit           = true;   
extern int        TP_Minimum                       = 60;     
extern int        TP_Diapazone                     = 21;     
extern int        StopLoss                         = 30;      
extern bool       StealthMode_StopLoss             = false;  
extern int        SL_Minimum                       = 150;    
extern int        SL_Diapazone                     = 21;     
extern int        TrailingStop                     = 15;     
extern int        TS_StartAfterProfit              = 15;     
extern int        TS_Step                          = 1;      
extern int        MoveToBE                         = 0;      
extern int        MoveToBE_Offset                  = 1;      
extern int        Slippage                         = 2;
extern double     MaxSpread                        = 5.0;
extern string     TimeManagement                   = "-------Time Management------";
extern bool       UseFilterTime                    = false;  
extern bool       UseAutoGMToffset                 = false;  
extern int        ManualGMToffset                  = 2;      
extern int        StartTradeHour                   = 21;     
extern int        StartTradeMinute                 = 0;      
extern int        FinishTradeHour                  = 2;      
extern int        FinishTradeMinute                = 0;      
extern string     LotsManagement                   = "-------Lots Management------";
extern double     Lots                             = 0.1;    
extern bool       UseMM                            = False;  
extern double     LotsRiskReductor                 = 5;      
extern double     MaxLots                          = 10;     
extern string     OtherParameters                  = "-----------------------------------------";
extern int        MagicNumber                      = 20101126;
extern string     ExpertComment                    = "my ea"; 
extern bool       SendEmail                        = False;    
extern bool       SoundAlert                       = False;    
extern string     SoundFileAtOpen                  = "alert.wav"; 
extern string     SoundFileAtClose                 = "alert.wav"; 
extern color      ColorBuy                         = Blue;     
extern color      ColorSell                        = Red;      
extern bool       WriteLog                         = True;
extern bool       WriteDebugLog                    = False;

bool              EnableBB                         = True;
int               BBSignal                         = EMPTY_VALUE;
string            text                             = "";

static bool     OpenTryAgain           = true;
static int      attempts_open          = 2;   
static int      max_difference         = 1;   
static int      slippage;              
static int      correction;            
static int      digits;
static double   point;
static string   comm_gmtoffset_value;  
static int      start_trade_hour;      
static int      finish_trade_hour;     
static bool     first_run_start        = true; 
static bool     is_testing;            
static string   URL                    = "http://hansbowles.com/gmt.php"; 
static string   Agent                  = "GmtOffset 1.0";
static int      hInternet;             
static int      lots_digits;
static datetime cur_time;
static double   maxlots;
static double   minlots;
static double   lotstep;
static string   symbol;
static double   percent_freemargin;    
static string   subject_open           = "New Trade Information";     
static string   subject_close          = "New Trade Information";     
static double   Points_TP;             
static double   Points_SL;             
static double   pnt_MaxSpread;         
static bool     print_log;             
static int      minimum_delay;         
static double   main_ts_distance;
static double   main_ts_step;
static double   main_ts_profit;
static double   main_be_profit;
static double   main_be_offset;
static double   current_stoploss_price;
static datetime bartime;               
static string   path_screenshots;
static bool     Filter_AverageRange;
static bool     Filter_MaximumRange;
static bool     block_buy_signal;
static bool     block_sell_signal;
static datetime prev_set_levels;       
static double   buy_sl = 0;            
static double   buy_tp = 0;            
static double   sell_sl = 0;           
static double   sell_tp = 0;       

//---------------------------------------------------------------------------------------------+
//---- init -----------------------------------------------------------------------------------+
//---------------------------------------------------------------------------------------------+
int init(){  
   symbol = Symbol();
   maxlots = MarketInfo(symbol,MODE_MAXLOT);
   minlots = MarketInfo(symbol,MODE_MINLOT);
   lotstep = MarketInfo(symbol,MODE_LOTSTEP);
   if(lotstep == 0.01) lots_digits = 2;
   else if(lotstep == 0.1) lots_digits = 1;
        else if(lotstep == 1) lots_digits = 0;
             else if(lotstep == 0.001) lots_digits = 3;
                  else lots_digits = 4;
   double Leverage = AccountLeverage();
   percent_freemargin = NormalizeDouble(LotsRiskReductor*(100/Leverage),2);
   if(Digits < 4) {
      point = 0.01;
      digits = 2;
   } else {
      point = 0.0001;
      digits = 4;
   }
   correction = MathPow(10,Digits-digits);
   slippage = Slippage * correction;
   is_testing = IsTesting();
   first_run_start = true; 
   Points_SL = NormalizeDouble((-1) * StopLoss * point,digits);
   Points_TP = NormalizeDouble(TakeProfit * point,digits);
   pnt_MaxSpread = NormalizeDouble(MaxSpread * point,Digits);
   main_ts_distance = NormalizeDouble(TrailingStop * point,digits);
   main_ts_profit   = NormalizeDouble(TS_StartAfterProfit * point,digits);
   main_ts_step     = NormalizeDouble(TS_Step * point,digits);
   main_be_profit   = NormalizeDouble(MoveToBE * point,digits);
   main_be_offset   = NormalizeDouble(MoveToBE_Offset * point,digits);
   bartime = Time[0]; 
   if(!EnableBB) {
      Comment("Warning, you have not enabled an any indicator!");
   }
   return(0);
}

//---------------------------------------------------------------------------------------------+
//---- deinit ---------------------------------------------------------------------------------+
//---------------------------------------------------------------------------------------------+
int deinit() {
   Comment("");
   return(0);
}

//---------------------------------------------------------------------------------------------+
//---- start ----------------------------------------------------------------------------------+
//---------------------------------------------------------------------------------------------+
int start()
  {   
   if(first_run_start)
     {
      if(UseAutoGMToffset)
        {
         if(!is_testing)
           {
            ManualGMToffset = AutoGMTCalculation();
            if(ManualGMToffset == -2147483648)
              {
               Sleep(60000);
               return(0);
              }
           }
         else
           {
            static bool alert_GMT = true;
            if(alert_GMT)
              {
               Comment("Warning, use manual GMToffsets only on backtest.","\n",
                       "Automatic GMT offset calculation works only on live/demo trading","\n",
                       "and should be set as FALSE for backtests - strategy testing.");
               Alert("Warning, use manual GMToffsets only on backtest.","\n",
                     "Automatic GMT offset calculation works only on live/demo trading","\n",
                     "and should be set as FALSE for backtests - strategy testing.");
               Print("Warning, use manual GMToffsets only on backtest! Set UseAutoGMToffset = False.");
               alert_GMT = false;
              }
            return(0);
           }
         string str_mode = " (automatic)";
        }
      else str_mode = " (manual)";
      comm_gmtoffset_value = StringConcatenate("GmtOffset: ",DoubleToStr(ManualGMToffset,1),str_mode,"\n");
      start_trade_hour  = GetGMTCorrection(StartTradeHour);
      finish_trade_hour = GetGMTCorrection(FinishTradeHour);    
      first_run_start = false;
     }
   cur_time = TimeCurrent();
   SetOrderLevels();
   WatchLevels();
   if(TrailingStop > 0) WatchTrailingStop(main_ts_distance,main_ts_profit,main_ts_step,MagicNumber);
   if(MoveToBE > 0) WatchMoveSLToBE(main_be_profit,main_be_offset,MagicNumber);
   GetIndicatorSignals();
   symbol = Symbol();
   bool is_trading_time = true; 
   if(UseFilterTime)
     {
      if(!IsTradeTime(cur_time,start_trade_hour,StartTradeMinute,finish_trade_hour,FinishTradeMinute))
        {
         text = StringConcatenate("\nNow is not trading time.",text);
         is_trading_time = false;
         BBSignal    = EMPTY_VALUE;
        }
     }
   Comment(text);
   if(!is_trading_time) return(0);
      int total = OrdersTotal() - 1;
      for(int i=total; i>=0; i--)
        {
         if(!OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
           {
            if(WriteDebugLog) Print("HavePositions: OrderSelect() error = ",ErrorDescription(GetLastError()));
            continue;
           }
         if(OrderMagicNumber() != MagicNumber) continue;
         if(OrderSymbol() != symbol) continue;
         return(0);
        } 
   RefreshRates();
   if(NormalizeDouble(Ask - Bid,Digits) > pnt_MaxSpread)
     {
      if(WriteLog && !print_log)
        {
         Print("Spread is to high: Current spread = ",DoubleToStr(NormalizeDouble(Ask - Bid,Digits),Digits),",  MaxSpread = ",DoubleToStr(pnt_MaxSpread,Digits));
         Print("Will try again later when spreads come to normal.");
        }
      print_log = true;
      return(0);
     }
   else print_log = false;
   int TradeSignal = 0;
   if(CheckForOpenLong()) TradeSignal++;
   else if(CheckForOpenShort()) TradeSignal--;
   if(TradeSignal == 0) return(0);
   if(TradeSignal > 0)
     {
      if(MaxTrades == 1) int num_pos = CloseHavePositions(OP_SELL);
      else num_pos = HavePositions(-1);
      if(num_pos < 0)
        {
         bartime--;
         return(0);
        }
      if(num_pos >= MaxTrades) return(0);
      if(OpenPosition(OP_BUY) < 0) bartime--;
     }
   else
     {
      if(MaxTrades == 1) num_pos = CloseHavePositions(OP_BUY);
      else num_pos = HavePositions(-1);
      if(num_pos < 0)
        {
         bartime--;
         return(0);
        }
      if(num_pos >= MaxTrades) return(0);
      if(OpenPosition(OP_SELL) < 0) bartime--;
     }
   return(0);
  }
  
bool NewBar() {   
   static datetime lastbar = 0;   
   datetime curbar = Time[0];  
   if(lastbar!=curbar)
   {      
      lastbar=curbar;      
      return (true); 
   } else {
      return(false);   
   }
}  

void GetIndicatorSignals() { 
   text = "\n";  
   bool piviot_low_hit;
   static double price_low_5 = 0;
   if (EnableBB==True) 
   {
      if (NewBar()){
         //RULE 1
         if (Low[1] > Low[5] && Low[2] > Low[5] && Low[3] > Low[5] && Low[4] > Low[5] && Low[6] > Low[5] && Low[7] > Low[5] && Low[8] > Low[5] && Low[9] > Low[5]){
         piviot_low_hit = true;
         price_low_5 = Low[5]; //SAVING PRICE IN THE VARIABLE price_low_5
         } 
      }
      if (piviot_low_hit == true){
         if ((NormalizeDouble(Ask - Bid,Digits)) < (price_low_5)){  //WHEN ACTUALPRICE IS BELOW price_low_5 OPEN A SELL ORDER
            BBSignal=OP_SELL; //OPEN SELL (ONLY IIT OPENS NOW A NEW ORDER WHEN A NEW BAR OPENS AND NOT DURING A BAR
         }
      }      
   }
   text = text + "\n";
   text = text + "---------MARGIN CHECK--------------";
   text = text + "\nFree Margin: " + DoubleToStr(AccountFreeMargin(), 2);
   text = text + "\nUsed Margin: " + DoubleToStr(AccountMargin(), 2);
   text = text + "\n"; 
   text = text + "---------SPREAD CHECK--------------";  
   text = text + "\nMaxSpread: " + DoubleToStr(MaxSpread,Digits-digits);
   text = text + "\nCurrent Spread: " + DoubleToStr(MarketInfo(symbol,MODE_SPREAD)/correction,Digits-digits);
}

//---------------------------------------------------------------------------------------------+
//---- CheckForOpenLong -----------------------------------------------------------------------+
//---------------------------------------------------------------------------------------------+
bool CheckForOpenLong()
  {
   if(!EnableBB) return(false);
   if(((EnableBB  && BBSignal == OP_BUY) || !EnableBB))
      return(true);
   return(false);
  }

//---------------------------------------------------------------------------------------------+
//---- CheckForOpenShort ----------------------------------------------------------------------+
//---------------------------------------------------------------------------------------------+
bool CheckForOpenShort()
  {
   if(!EnableBB) return(false);
   if(((EnableBB  && BBSignal == OP_SELL) || !EnableBB))
      return(true);
   return(false);
  }

//---------------------------------------------------------------------------------------------+
//---- GetGMTCorrection -----------------------------------------------------------------------+
//---------------------------------------------------------------------------------------------+
int GetGMTCorrection(int hour)
  {
   hour = hour + ManualGMToffset;
   while(true)
     {
      if(hour >= 24) hour -= 24;
      else if(hour < 0) hour += 24;
           else break;
     }
   return(hour);
  }

//---------------------------------------------------------------------------------------------+
//---- AutoGMTCalculation ---------------------------------------------------------------------+
//---------------------------------------------------------------------------------------------+
int AutoGMTCalculation()
  {
   hInternet = InternetOpenA(Agent,0,"0","0",0);
   string resultStr;
   if(!GetData(URL,resultStr))
     {
      string message = "Error getting data to server.";
      Comment(message);
      Print(message);
      int GMT_Offset = -2147483648;
     }
   else
     {
      int time_diff = TimeCurrent() - StrToInteger(resultStr);
      GMT_Offset = MathFloor((time_diff + 1800) / 3600);
     }
   InternetCloseHandle(hInternet);
   return(GMT_Offset);
  }

//---------------------------------------------------------------------------------------------+
//---- GetData --------------------------------------------------------------------------------+
//---------------------------------------------------------------------------------------------+
bool GetData(string url, string &resultStr)
  {
   int handle = InternetOpenUrlA(hInternet,url,"0",0,-2080374528,0);
   if(handle == 0) return(false);
   int resultlength[] = {1};
   string buffer = "xxxxxxxxxx";
   int result = InternetReadFile(handle,buffer,10,resultlength);
   if(handle != 0) InternetCloseHandle(handle);
   resultStr = buffer;
   return(true);
  }
  
//---------------------------------------------------------------------------------------------+
//---- IsTradeTime ----------------------------------------------------------------------------+
//---------------------------------------------------------------------------------------------+
bool IsTradeTime(datetime c_time, int start_hour, int start_minute, int finish_hour, int finish_minute)
  {
   int cur_hour = TimeHour(c_time);
   int cur_min = TimeMinute(c_time);
   if(start_hour == finish_hour && start_minute == finish_minute) return(true);
   if(finish_minute == 0)
     {
      if(finish_hour == 0) int fth = 23;
      else fth = finish_hour - 1;
      int ftm = 59;      
     }
   else
     {
      fth = finish_hour;
      ftm = finish_minute - 1;      
     }
   if(start_hour == fth)
     {
      if(start_minute == ftm) return(true);
      if(start_minute < ftm)
        {
         if(cur_hour != start_hour) return(false);
         if(cur_min < start_minute || cur_min > ftm) return(false);
         return(true);
        }
      if(start_minute > ftm)
        {
         if(cur_hour == start_hour)
           {
            if(cur_min < start_minute && cur_min > ftm) return(false);
           }
         return(true);
        }
     }
   if(start_hour < fth)
     {
      if(cur_hour < start_hour || cur_hour > fth) return(false);
      if(cur_hour == start_hour && cur_min < start_minute) return(false);
      if(cur_hour == fth && cur_min > ftm) return(false);
      return(true);
     }
   if(start_hour > fth)
     {
      if(cur_hour < start_hour && cur_hour > fth) return(false);
      if(cur_hour == start_hour && cur_min < start_minute) return(false);
      if(cur_hour == fth && cur_min > ftm) return(false);
      return(true);
     }
   return(true);
  }
  
//---------------------------------------------------------------------------------------------+
//---- LotsOptimized --------------------------------------------------------------------------+
//---------------------------------------------------------------------------------------------+
double LotsOptimized()
  {
   if(!UseMM) double lot = Lots;
   else {
    if(UseMM)
     {
      double MoneyForTrade = AccountFreeMargin() * percent_freemargin / 100;
      double MarginForLotStep = MarketInfo(symbol,MODE_MARGINREQUIRED) * lotstep;
      lot = NormalizeDouble(MathFloor(MoneyForTrade/MarginForLotStep)*lotstep,lots_digits);
     }
   }
   if(lot > MaxLots) lot = MaxLots;
   if(lot < minlots) lot = minlots;
   else if(lot > maxlots) lot = maxlots;
   
   return(lot);
  }

//---------------------------------------------------------------------------------------------+
//---- OpenPosition --------------------------------------------------------------------------+
//---------------------------------------------------------------------------------------------+
int OpenPosition(int cmd)
  {
   BBSignal    = EMPTY_VALUE;
   double lots = LotsOptimized();
   if(AccountFreeMarginCheck(symbol,cmd,lots) <= 0 || GetLastError() == 134)
     {
      Print("OpenPosition: You don\'t have free margin.");
      return(-1);
     }
   RefreshRates();
   if(cmd == OP_BUY)
     {
      double open_price = NormalizeDouble(Ask,Digits);
      color cmd_color = ColorBuy;
     }
   else
     {
      open_price = NormalizeDouble(Bid,Digits);
      cmd_color = ColorSell;
     }
   int attempt = attempts_open;
   while(attempt > 0)
     {
      int ticket = OrderSend(symbol,cmd,lots,open_price,slippage,0,0,ExpertComment,MagicNumber,0,cmd_color);
      if(ticket < 0)
        {
         int error = GetLastError();
         if(WriteDebugLog) Print("OpenPosition: OrderSend(",OrderTypeToStr(cmd),") error = ",ErrorDescription(error));
         if(error != 136) break;
         if(!OpenTryAgain) break;
         // ERR_OFF_QUOTES
         Sleep(6000);
         RefreshRates();
         if(cmd == OP_BUY) double next_price = NormalizeDouble(Ask,Digits);
         else next_price = NormalizeDouble(Bid,Digits);
         if(NormalizeDouble(MathAbs((next_price - open_price)/point),0) > max_difference) break;
         open_price = next_price;
         attempt--;
         if(attempt > 0) Print("OpenPosition: ... Possible to open order.");
         lots = NormalizeDouble(lots / 2,lots_digits);
         if(lots < minlots) lots = minlots;
        }
      else
        {
         if(OrderSelect(ticket,SELECT_BY_TICKET)) open_price = OrderOpenPrice();
         if(SendEmail) SendMail(subject_open,StringConcatenate("EA\nCurrency Pair: ",StringSubstr(symbol,0,6),"\nTime: ",TimeToStr(TimeCurrent(),TIME_DATE|TIME_MINUTES|TIME_SECONDS),"\nOrder Type: ",OrderTypeToStr(cmd),"\nPrice: ",DoubleToStr(open_price,Digits),"\nLot size: ",DoubleToStr(lots,lots_digits),"\nEvent: Trade Opened","\n\nCurrent Balance: ",DoubleToStr(AccountBalance(),2)," ",AccountCurrency(),"\nCurrent Equity: ",DoubleToStr(AccountEquity(),2)," ",AccountCurrency()));
         if(SoundAlert) PlaySound(SoundFileAtOpen);
         current_stoploss_price = 0;
         break;
        }
     }
   return(ticket);
  }

//---------------------------------------------------------------------------------------------+
//---- WatchLevels ----------------------------------------------------------------------------+
//---------------------------------------------------------------------------------------------+
void WatchLevels()
  {
   if(TakeProfit <= 0 && StopLoss <= 0) return;
   int total = OrdersTotal() - 1;
   for(int i=total; i>=0; i--)
     {
      if(!OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
        {
         if(WriteDebugLog) Print("WatchLevels: OrderSelect() error = ",ErrorDescription(GetLastError()));
         continue;
        }
      if(OrderMagicNumber() != MagicNumber) continue;
      if(OrderType() > OP_SELL) continue;
      if(OrderSymbol() != symbol) continue;
      double order_close_price = NormalizeDouble(OrderClosePrice(),Digits);
      double order_open_price  = NormalizeDouble(OrderOpenPrice(), Digits);
      if(OrderType() == OP_BUY)
        {
         double profit = NormalizeDouble(order_close_price - order_open_price,Digits);
         if((Points_TP > 0 && profit >= Points_TP) || (Points_SL < 0 && profit <= Points_SL))
           {
            if(WriteDebugLog) Print("WatchLevels: level for close BUY");
            CloseOrder(OrderTicket(),OrderLots(),OP_BUY,slippage);
           }
        }
      else
        {
         profit = NormalizeDouble(order_open_price - order_close_price,Digits);
         if((Points_TP > 0 && profit >= Points_TP) || (Points_SL < 0 && profit <= Points_SL))
           {
            if(WriteDebugLog) Print("WatchLevels: level for close SELL");
            CloseOrder(OrderTicket(),OrderLots(),OP_SELL,slippage);
           }
        }
     }
   return;
  }

//---------------------------------------------------------------------------------------------+
//---- OrderTypeToStr -------------------------------------------------------------------------+
//---------------------------------------------------------------------------------------------+
string OrderTypeToStr(int order_type)
  {
   switch(order_type)
     {
      case OP_BUY: string result = "Buy";       break;
      case OP_SELL:       result = "Sell";      break;
      case OP_BUYLIMIT:   result = "BuyLimit";  break;
      case OP_SELLLIMIT:  result = "SellLimit"; break;
      case OP_BUYSTOP:    result = "BuyStop";   break;
      case OP_SELLSTOP:   result = "SellStop";  break;
      default:            result = "Unknown";   break;
     }
   return(result);
  }

//---------------------------------------------------------------------------------------------+
//---- CloseOrder -----------------------------------------------------------------------------+
//---------------------------------------------------------------------------------------------+
bool CloseOrder(int order_ticket, double order_lots, int order_type, int order_slippage)
  {
   if(order_type == OP_BUY) color CloseColor = ColorBuy;
   else CloseColor = ColorSell;
   int err_129 = 0;
   int err_130 = 0;
   int err_137 = 0;
   int err_138 = 0;
   while(true)
     {
      while(!IsTradeAllowed()) Sleep(1000);
      RefreshRates();
      if(order_type == OP_BUY) double order_close_price = NormalizeDouble(Bid,Digits);
      else order_close_price = NormalizeDouble(Ask,Digits);
      bool error = OrderClose(order_ticket,order_lots,order_close_price,order_slippage,CloseColor);
      if(!error)
        {
         int err = GetLastError();
         if(WriteDebugLog) Print("OrderClose(",OrderTypeToStr(order_type),",",order_ticket,") error = ",ErrorDescription(err));
         bool cont = false;
         switch(err)
           {
            case    0:        
               Sleep(10000);
               if(OrderSelect(order_ticket,SELECT_BY_TICKET)) if(OrderCloseTime() == 0) cont = true;
               break;
            case    1: break; 
            case    2: break; 
            case    3: break; 
            case    4: break; 
            case    5: break; 
            case    6:        
               Sleep(10000);
               if(IsConnected()) cont = true;
               break;
            case    7: break; 
            case    8: break; 
            case    9: break; 
            case   64: break; 
            case   65: break; 
            case  128:        
               Sleep(70000);
               if(OrderSelect(order_ticket,SELECT_BY_TICKET)) if(OrderCloseTime() == 0) cont = true;
               break;
            case  129:        
               Sleep(6000);
               err_129++;
               if(err_129 <= 3) cont = true;
               break;
            case  130:        
               Sleep(6000);
               err_130++;
               if(err_130 <= 3) cont = true;
               break;
            case  131: break; 
            case  132: break; 
            case  133: break; 
            case  134: break; 
            case  135:        
               cont = true;
               break;
            case  136:        
               Sleep(6000);
               cont = true;
               break;
            case  137:        
               Sleep(20000);
               err_137++;
               if(err_137 <= 3) cont = true;
               break;
            case  138:        
               err_138++;
               if(err_138 <= 3) cont = true;
               break;
            case  139: break; 
            case  140: break; 
            case  141: break; 
            case  142:        
               Sleep(70000);
               if(OrderSelect(order_ticket,SELECT_BY_TICKET)) if(OrderCloseTime() == 0) cont = true;
               break;
            case  143:        
               Sleep(70000);
               if(OrderSelect(order_ticket,SELECT_BY_TICKET)) if(OrderCloseTime() == 0) cont = true;
               break;
            case  144: break; 
            case  145:        
               Sleep(20000);
               cont = true;
               break;
            case  146:        
               while(IsTradeContextBusy()) Sleep(1000);
               cont = true;
               break;
            case  147: break; 
            case  148: break; 
            case 4000:        
               Sleep(10000);
               if(OrderSelect(order_ticket,SELECT_BY_TICKET)) if(OrderCloseTime() == 0) cont = true;
               break;
            case 4051: break; 
            case 4062: break; 
            case 4063: break; 
            case 4064: break; 
            case 4105: break; 
            case 4106: break; 
            case 4107: break; 
            case 4108: break; 
            case 4109: break; 
            case 4110: break; 
            case 4111: break; 
           }
         if(!cont) break;
        }
      else
        {
         if(OrderSelect(order_ticket,SELECT_BY_TICKET)) order_close_price = OrderClosePrice();
         if(SendEmail) SendMail(subject_close,StringConcatenate("HansBowles FX Premium Package Information\nCurrency Pair: ",StringSubstr(symbol,0,6),"\nTime: ",TimeToStr(TimeCurrent(),TIME_DATE|TIME_MINUTES|TIME_SECONDS),"\nOrder Type: ",OrderTypeToStr(order_type),"\nPrice: ",DoubleToStr(order_close_price,Digits),"\nLot size: ",DoubleToStr(order_lots,lots_digits),"\nEvent: Trade Closed","\n\nCurrent Balance: ",DoubleToStr(AccountBalance(),2)," ",AccountCurrency(),"\nCurrent Equity: ",DoubleToStr(AccountEquity(),2)," ",AccountCurrency()));
         if(SoundAlert) PlaySound(SoundFileAtClose);
         break;
        }
     }
   return(error);
  }

//---------------------------------------------------------------------------------------------+
//---- SetOrderLevels -------------------------------------------------------------------------+
//---------------------------------------------------------------------------------------------+
void SetOrderLevels()
  {
   double stoplevel = NormalizeDouble(MarketInfo(symbol,MODE_STOPLEVEL)*Point,Digits);
   int total = OrdersTotal() - 1;
   for(int i=total; i>=0; i--)
     {
      if(!OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
        {
         if(WriteDebugLog) Print("SetOrderLevels: OrderSelect() error = ",ErrorDescription(GetLastError()));
         continue;
        }
      if(OrderMagicNumber() != MagicNumber) continue;
      if(OrderType() > OP_SELL) continue;
      if(OrderSymbol() != symbol) continue;
      double order_close_price = NormalizeDouble(OrderClosePrice(),Digits);
      double order_open_price  = NormalizeDouble(OrderOpenPrice(), Digits);
      double order_stop_loss   = NormalizeDouble(OrderStopLoss(),  Digits);
      double order_take_profit = NormalizeDouble(OrderTakeProfit(),Digits);
      bool to_modify_sl = false;
      if(order_stop_loss == 0)
        {
         if(StealthMode_StopLoss) int sl = SL_Minimum + MathRand()%SL_Diapazone;
         else sl = StopLoss;
         if(sl != 0)
           {
            if(OrderType() == OP_BUY)
              {
               double stoploss = NormalizeDouble(order_open_price - sl*point,Digits);
               if(NormalizeDouble(order_close_price - stoploss,Digits) > stoplevel) to_modify_sl = true;
              }
            else
              {
               stoploss = NormalizeDouble(order_open_price + sl*point,Digits);
               if(NormalizeDouble(stoploss - order_close_price,Digits) > stoplevel) to_modify_sl = true;
              }
           }
         else stoploss = order_stop_loss;
        }
      else stoploss = order_stop_loss;
      bool to_modif_tp = false;
      if(order_take_profit == 0)
        {
         if(StealthMode_TakeProfit) int tp = TP_Minimum + MathRand()%TP_Diapazone;
         else tp = TakeProfit;
         if(tp != 0)
           {
            if(OrderType() == OP_BUY)
              {
               double takeprofit = NormalizeDouble(order_open_price + tp*point,Digits);
               if(NormalizeDouble(takeprofit - order_close_price,Digits) > stoplevel) to_modif_tp = true;
              }
            else
              {
               takeprofit = NormalizeDouble(order_open_price - tp*point,Digits);
               if(NormalizeDouble(order_close_price - takeprofit,Digits) > stoplevel) to_modif_tp = true;
              }
           }
         else takeprofit = order_take_profit;
        }
      else takeprofit = order_take_profit;
      if(to_modify_sl || to_modif_tp)
        {
         while(!IsTradeAllowed()) Sleep(1000);
         bool error = OrderModify(OrderTicket(),order_open_price,stoploss,takeprofit,0,CLR_NONE);
         if(!error)
           {
            if(WriteDebugLog) Print("SetOrderLevels: OrderModify(OP_SELL) error = ",ErrorDescription(GetLastError()));
           }
         else
           {
            current_stoploss_price = stoploss;
           }
        }
     }
   return;
  }
  
//---------------------------------------------------------------------------------------------+
//---- CloseHavePositions ---------------------------------------------------------------------+
//---------------------------------------------------------------------------------------------+
int CloseHavePositions(int cmd)
  {
   if(cmd == OP_BUY) color CloseColor = ColorBuy;
   else CloseColor = ColorSell;
   int numpos = 0;
   int return_code = 0;
   int total = OrdersTotal() - 1;
   for(int i=total; i>=0; i--)
     {
      if(!OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
        {
         if(WriteDebugLog) Print("CloseHavePositions: OrderSelect() error = ",ErrorDescription(GetLastError()));
         continue;
        }
      if(OrderMagicNumber() != MagicNumber) continue;
      if(OrderSymbol() != symbol) continue;
      int order_type = OrderType();
      if(order_type > OP_SELL) continue;
      if(order_type != cmd)
        {
         numpos++;
         continue;
        }
      else
        {
         bool error = CloseOrder(OrderTicket(),OrderLots(),order_type,slippage);
         if(!error) return_code = -1;
        }
     }
   if(return_code != 0) return(return_code);
   return(numpos);
  }

//---------------------------------------------------------------------------------------------+
//---- HavePositions --------------------------------------------------------------------------+
//---------------------------------------------------------------------------------------------+
int HavePositions(int cmd)
  {
   int numpos = 0;
   int total = OrdersTotal() - 1;
   for(int i=total; i>=0; i--)
     {
      if(!OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
        {
         if(WriteDebugLog) Print("HavePositions: OrderSelect() error = ",ErrorDescription(GetLastError()));
         continue;
        }
      if(OrderMagicNumber() != MagicNumber) continue;
      if(OrderSymbol() != symbol) continue;
      int order_type = OrderType();
      if(order_type > OP_SELL) continue;
      if(cmd >= 0) if(order_type != cmd) continue;
      numpos++;
     }
   return(numpos);
  }

//---------------------------------------------------------------------------------------------+
//---- TrailingStop ---------------------------------------------------------------------------+
//---------------------------------------------------------------------------------------------+
void WatchTrailingStop(double ts_distance, double ts_profit, double ts_step, int magic_number)
  {
   RefreshRates();
   double stoplevel = NormalizeDouble(MarketInfo(symbol,MODE_STOPLEVEL) * Point,Digits);
   double buy_new_stoploss  = NormalizeDouble(Bid - ts_distance,Digits);
   double sell_new_stoploss = NormalizeDouble(Ask + ts_distance,Digits);
   int total = OrdersTotal() - 1;
   for(int i=total; i>=0; i--)
     {
      if(!OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
        {
         if(WriteDebugLog) Print("WatchTrailingStop: OrderSelect() error = ",ErrorDescription(GetLastError()));
         continue;
        }
      if(OrderMagicNumber() != magic_number) continue;
      if(OrderType() > OP_SELL) continue;
      if(OrderSymbol() != symbol) continue;
      double order_open_price  = NormalizeDouble(OrderOpenPrice(), Digits);
      double order_close_price = NormalizeDouble(OrderClosePrice(),Digits);
      double order_stop_loss   = NormalizeDouble(OrderStopLoss(),  Digits);
      if(OrderType() == OP_BUY)
        {
         if(current_stoploss_price != 0) order_stop_loss = NormalizeDouble(MathMax(order_stop_loss,current_stoploss_price),Digits);
         if(NormalizeDouble(order_close_price - order_open_price,Digits) < ts_profit) continue;
         if(order_close_price <= buy_new_stoploss || order_close_price <= order_stop_loss)
           {
            if(WriteDebugLog) Print("WatchTrailingStop: closing by stealth trailing stop.");
            bool error = CloseOrder(OrderTicket(),OrderLots(),OrderType(),slippage);
           }
         else
           {
            if(order_stop_loss >= buy_new_stoploss) continue;
            if(NormalizeDouble(buy_new_stoploss - order_stop_loss,Digits) < ts_step) continue;
            current_stoploss_price = buy_new_stoploss;
            if(NormalizeDouble(order_close_price - buy_new_stoploss,Digits) <= stoplevel)
              {
               if(WriteDebugLog) Print("WatchTrailingStop: ticket ",OrderTicket()," = it is impossible to move, the level stop-loss is near to the close price.");
               continue;
              }
            while(!IsTradeAllowed()) Sleep(1000);
            error = OrderModify(OrderTicket(),OrderOpenPrice(),buy_new_stoploss,OrderTakeProfit(),0,ColorBuy);
            if(!error)
              {
               if(WriteDebugLog) Print("WatchTrailingStop: OrderModify(",OrderTypeToStr(OrderType()),",",OrderTicket(),") error = ",ErrorDescription(GetLastError()));
              }
           }
        }
      else
        {
         if(current_stoploss_price != 0)
           {
            if(order_stop_loss != 0) order_stop_loss = NormalizeDouble(MathMin(order_stop_loss,current_stoploss_price),Digits);
            else order_stop_loss = current_stoploss_price;
           }
         if(NormalizeDouble(order_open_price - order_close_price,Digits) < ts_profit) continue;
         if(order_close_price >= sell_new_stoploss || (order_close_price >= order_stop_loss && order_stop_loss != 0))
           {
            if(WriteDebugLog) Print("WatchTrailingStop: closing by stealth trailing stop.");
            error = CloseOrder(OrderTicket(),OrderLots(),OrderType(),slippage);
           }
         else
           {
            if(order_stop_loss != 0 && order_stop_loss <= sell_new_stoploss) continue;
            if(order_stop_loss != 0 && NormalizeDouble(order_stop_loss - sell_new_stoploss,Digits) < ts_step) continue;
            current_stoploss_price = sell_new_stoploss;
            if(NormalizeDouble(sell_new_stoploss - order_close_price,Digits) <= stoplevel)
              {
               if(WriteDebugLog) Print("WatchTrailingStop: ticket ",OrderTicket()," = it is impossible to move, the level stop-loss is near to the close price.");
               continue;
              }
            while(!IsTradeAllowed()) Sleep(1000);
            error = OrderModify(OrderTicket(),OrderOpenPrice(),sell_new_stoploss,OrderTakeProfit(),0,ColorSell);
            if(!error)
              {
               if(WriteDebugLog) Print("WatchTrailingStop: OrderModify(",OrderTypeToStr(OrderType()),",",OrderTicket(),") error = ",ErrorDescription(GetLastError()));
              }
           }
        }
     }
  }

//---------------------------------------------------------------------------------------------+
//---- WatchMoveSLToBE ------------------------------------------------------------------------+
//---------------------------------------------------------------------------------------------+
void WatchMoveSLToBE(double be_profit, double be_offset, int magic_number)
  {
   int total = OrdersTotal() - 1;
   double stoplevel = NormalizeDouble(MarketInfo(symbol,MODE_STOPLEVEL)*Point,Digits);
   for(int i=total; i>=0; i--)
     {
      if(!OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
        {
         if(WriteDebugLog) Print("MoveSLtoBE: OrderSelect() error = ",ErrorDescription(GetLastError()));
         continue;
        }
      if(OrderMagicNumber() != magic_number) continue;
      if(OrderType() > OP_SELL) continue;
      if(OrderSymbol() != symbol) continue;
      double order_open_price  = NormalizeDouble(OrderOpenPrice(), Digits);
      double order_stop_loss   = NormalizeDouble(OrderStopLoss(),  Digits);
      double order_close_price = NormalizeDouble(OrderClosePrice(),Digits);
      if(OrderType() == OP_BUY)
        {
         double new_stop_loss = NormalizeDouble(order_open_price + be_offset,Digits);
         if(order_stop_loss >= new_stop_loss) continue;
         double order_profit = NormalizeDouble(order_close_price - order_open_price,Digits);
         color ColorMove = ColorBuy;
        }
      else
        {
         new_stop_loss = NormalizeDouble(order_open_price - be_offset,Digits);
         if(order_stop_loss != 0 && order_stop_loss <= new_stop_loss) continue;
         order_profit = NormalizeDouble(order_open_price - order_close_price,Digits);
         ColorMove = ColorSell;
        }
      if(order_profit <  be_profit) continue;
      if(order_profit <= stoplevel)
        {
         if(WriteDebugLog) Print("MoveSLToBE: ticket ",OrderTicket()," = it is impossible to move, the level stop-loss is near to the close price.");
         continue;
        }
      while(!IsTradeAllowed()) Sleep(1000);
      bool error = OrderModify(OrderTicket(),order_open_price,new_stop_loss,OrderTakeProfit(),0,ColorMove);
      if(!error)
        {
         if(WriteDebugLog) Print("MoveSLtoBE: OrderModify(",OrderTypeToStr(OrderType()),",",OrderTicket(),") error = ",ErrorDescription(GetLastError()));
        }
      else
        {
         current_stoploss_price = new_stop_loss;
        }
     }
  }